## guitar 1.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(Guitar
	VERSION 1.0.0
	LANGUAGES CXX C
)
set(CMAKE_CXX_EXTENSIONS  OFF)
set(CMAKE_CXX_STANDARD    17)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Disable in-source-build
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
set(CMAKE_DISABLE_SOURCE_CHANGES  ON)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR})

find_package(Qt5 COMPONENTS Core Widgets Network Svg REQUIRED)
find_package(zlib REQUIRED )
find_package(OpenSSL REQUIRED )
find_package(Qt5LinguistTools REQUIRED)
if(WIN32)
	# check package at
	# https://github.com/rprichard/winpty
	find_package(winpty REQUIRED )
endif()

# extract version information
string(TIMESTAMP Guitar_copyright_year "%Y")
execute_process(
	COMMAND git rev-parse --short=7 HEAD
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
	OUTPUT_VARIABLE Guitar_git_hash
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

configure_file(version.h.in version.h)
configure_file(win.rc.in win.rc.h)
configure_file(Info.plist.in Info.plist)


add_subdirectory(src)
#add_subdirectory(extra)

=== src/CMakeLists.txt ===
add_definitions(-DAPP_GUITAR)

# Sourceを再帰的に取得
file(GLOB_RECURSE Guitar_SOURCES  ./*.cpp)


if(WIN32)
# win32環境においてunix関係のアイテムを使用しないように
	file(GLOB uinx_src ./unix/*.cpp)
	list(REMOVE_ITEM Guitar_SOURCES ${uinx_src})
elseif(UNIX)
# unix環境においてwin32関係のアイテムを使用しないように
	file(GLOB_RECURSE win32_src ./win32/*.cpp)
	list(REMOVE_ITEM Guitar_SOURCES ${win32_src})
endif()

# main.cppは別個にコンパイルしたいのでリストから除外
list(REMOVE_ITEM Guitar_SOURCES main.cpp)

file(GLOB_RECURSE Guitar_UIS  ./*.ui)

file(GLOB_RECURSE Guitar_RESOURCES   ./resources/*.qrc)

file(GLOB_RECURSE Guitar_TRANSLATIONS  ./resources/translations/*.ts)
qt5_add_translation(Guitar_QM_FILES ${Guitar_TRANSLATIONS})

configure_file(${Guitar_RESOURCES} ${CMAKE_BINARY_DIR} COPYONLY)

add_custom_target(translations ALL DEPENDS ${Guitar_QM_FILES})
add_custom_target(resources ALL DEPENDS ${Guitar_RESOURCES})
add_dependencies(resources translations)

# Sourceをライブラリとして構築する
add_library(guitar-lib ${Guitar_SOURCES})
target_link_libraries(guitar-lib PUBLIC
	Qt5::Widgets
	Qt5::Network
	Qt5::Svg
	zlib 
	OpenSSL::SSL
	OpenSSL::Crypto
	)


# ライブラリに読み込むHeaderの設定
target_include_directories(guitar-lib PUBLIC ${CMAKE_BINARY_DIR})
target_include_directories(guitar-lib PUBLIC ${PROJECT_SOURCE_DIR}/src)
target_include_directories(guitar-lib PUBLIC ${PROJECT_SOURCE_DIR}/src/texteditor)

set_target_properties(guitar-lib PROPERTIES OUTPUT_NAME guitar)

# main.cppのコンパイル
add_executable(${PROJECT_NAME} 
		main.cpp
		${Guitar_RESOURCES}
		${Guitar_QM_FILES}
		${Guitar_UIS}
		)

# main.cppとそれ以外をリンク
target_link_libraries(${PROJECT_NAME} guitar-lib)

=== debian/changelog ===
guitar (1.2.0-1) groovy; urgency=medium

  * Initial release.

 -- Chris <dpkg@chris-nz.com>  Fri, 16 Apr 2021 22:00:24 +1200

=== debian/control ===
Source: guitar
Section: vcs
Priority: optional
Maintainer: Chris <dpkg@chris-nz.com>
Build-Depends: cmake, debhelper,
                                libqt5svg5-dev,
                                libssl-dev,
                                qtbase5-dev,
                                qttools5-dev,
                                zlib1g-dev
Standards-Version: 4.4.1
Homepage: https://github.com/soramimi/Guitar

Package: guitar
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Git GUI Client
 Guitar is a git GUI in Qt5.
 .
 Guitar can do merges, inspect log and graph,
 and most other things you'd want from a GUI client.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_CXXFLAGS_MAINT_APPEND = -DQT_NO_DEBUG_OUTPUT -DQT_NO_WARNING_OUTPUT

%:
	dh $@ --buildsystem=cmake


# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- #	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

## guitar 1.2.999

=== extra/CMakeLists.txt ===
add_subdirectory(FileView)

=== debian/changelog ===
guitar (1.2.999-1) groovy; urgency=medium

  * Improve Update deps and copyright

 -- Chris <dpkg@chris-nz.com>  Fri, 16 Apr 2021 23:41:14 +1200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: vcs
 Priority: optional
 Maintainer: Chris <dpkg@chris-nz.com>
-Build-Depends: cmake, debhelper,
+Build-Depends: cmake, debhelper, git,
                                 libqt5svg5-dev,
                                 libssl-dev,
                                 qtbase5-dev,
